package com.zyqb;

import cn.banny.unidbg.linux.android.dvm.VM;
import cn.banny.unidbg.LibraryResolver;
import cn.banny.unidbg.Module;
import cn.banny.unidbg.arm.ARMEmulator;
import cn.banny.unidbg.linux.android.AndroidARMEmulator;
import cn.banny.unidbg.linux.android.AndroidResolver;
import cn.banny.unidbg.linux.android.dvm.*;
import cn.banny.unidbg.memory.Memory;
import java.io.File;
import java.io.IOException;


public class ZyqbEncrypt extends AbstractJni {

    private static final String APP_PACKAGE_NAME = "com.youcash.ZYWallet";
    private static final String NATIVE_CLASS_NAME = "com/csii/powerenter/PEJNILib";
    private static LibraryResolver createLibraryResolver() {
        return new AndroidResolver(23);
    }
    private static ARMEmulator createARMEmulator() {
        return new AndroidARMEmulator(APP_PACKAGE_NAME);
    }

    private final DvmClass ZyqbEncrypt;
    private final ARMEmulator emulator;
    private final Module module;
    private final VM vm;

    ZyqbEncrypt() throws IOException {
        emulator = createARMEmulator();
        final Memory memory = emulator.getMemory();
        memory.setLibraryResolver(createLibraryResolver());
        memory.setCallInitFunction();

        vm = emulator.createDalvikVM(null);
        DalvikModule dm = vm.loadLibrary(new File("src/test/resources/example_binaries/armeabi-v7a/libcsiipowerenter.so"), false);
        vm.setJni(this);
        dm.callJNI_OnLoad(emulator);
        module = dm.getModule();
        ZyqbEncrypt = vm.resolveClass(NATIVE_CLASS_NAME);
    }

    void destroy() throws IOException {
        emulator.close();
        System.out.println("destroy");
    }

    public static void main(String[] args) throws Exception {
        ZyqbEncrypt test = new ZyqbEncrypt();
        test.sign(String.valueOf(System.currentTimeMillis()));
        test.destroy();
    }

    void sign(String ts) {
        Number ret = ZyqbEncrypt.callStaticJniMethod(emulator,
                "getNativeCiphertext(" +
                        "I" +
                        "Ljava/lang/String;)" +
                        "Ljava/lang/String;",
                0,
                vm.addLocalObject(new StringObject(vm, "1568008879630")));
        System.out.println("MacValue ret:" + ret);

//        long hash = ret.intValue() & 0xffffffffL;
//        StringObject sign = vm.getObject(hash);
//        vm.deleteLocalRefs();
//        System.out.println("MacValue:" + sign.getValue().substring(0, 8));
//        return sign.getValue().substring(0, 8);
    }

    @Override
    public DvmObject callStaticObjectMethod(BaseVM vm, DvmClass dvmClass, String signature, VarArg varArg) {
        if ("java/lang/System->getProperty(Ljava/lang/String;)Ljava/lang/String;".equals(signature)) {
            StringObject string = varArg.getObject(0);
            return new StringObject(vm, System.getProperty(string.getValue()));
        }
        return super.callStaticObjectMethod(vm, dvmClass, signature, varArg);
    }

}
